diff -uNr djbdns-1.05/query.c djbdns-1.05-new/query.c
--- djbdns-1.05/query.c	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/query.c	2003-09-16 10:16:42.000000000 -0400
@@ -12,12 +12,13 @@
 #include "alloc.h"
 #include "response.h"
 #include "query.h"
+#include "ip6.h"
 
-static int flagforwardonly = 0;
+extern char ignoreip[];
 
-void query_forwardonly(void)
+static int isForwardOnly (const struct query *z)
 {
-  flagforwardonly = 1;
+  return z->controltype[z->level] == DNSCACHES;
 }
 
 static void cachegeneric(const char type[2],const char *d,const char *data,unsigned int datalen,uint32 ttl)
@@ -110,7 +111,7 @@
   return 1;
 }
 
-static int globalip(char *d,char ip[4])
+static int globalip(char *d,char ip[16])
 {
   if (dns_domain_equal(d,"\011localhost\0")) {
     byte_copy(ip,4,"\177\0\0\1");
@@ -165,7 +166,7 @@
   char *buf;
   unsigned int len;
   const char *whichserver;
-  char header[12];
+  char header[24];
   char misc[20];
   unsigned int rcode;
   unsigned int posanswers;
@@ -193,6 +194,7 @@
   int k;
   int p;
   int q;
+  int sc;
 
   errno = error_io;
   if (state == 1) goto HAVEPACKET;
@@ -210,9 +212,10 @@
 
   if (globalip(d,misc)) {
     if (z->level) {
-      for (k = 0;k < 64;k += 4)
-        if (byte_equal(z->servers[z->level - 1] + k,4,"\0\0\0\0")) {
-	  byte_copy(z->servers[z->level - 1] + k,4,misc);
+      for (k = 0;k < 256;k += 16)
+        if (byte_equal(z->servers[z->level - 1] + k,16,V6any)) {
+	  byte_copy(z->servers[z->level - 1] + k,12,V4mappedprefix);
+	  byte_copy(z->servers[z->level - 1] + k + 12,4,misc);
 	  break;
 	}
       goto LOWERLEVEL;
@@ -227,6 +230,158 @@
     return 1;
   }
 
+  if (dns_domain_equal(d,"\0011\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\003ip6\003int\0")) {
+    if (z->level) goto LOWERLEVEL;
+    if (!rqa(z)) goto DIE;
+    if (typematch(DNS_T_PTR,dtype)) {
+      if (!response_rstart(d,DNS_T_PTR,655360)) goto DIE;
+      if (!response_addname("\016ipv6-localhost\0")) goto DIE;
+      if (!response_addname("\015ipv6-loopback\0")) goto DIE;
+      response_rfinish(RESPONSE_ANSWER);
+    }
+    cleanup(z);
+    return 1;
+  }
+
+  if (dns_domain_equal(d,"\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\001e\001f\003ip6\003int\0")) {
+    if (z->level) goto LOWERLEVEL;
+    if (!rqa(z)) goto DIE;
+    if (typematch(DNS_T_PTR,dtype)) {
+      if (!response_rstart(d,DNS_T_PTR,655360)) goto DIE;
+      if (!response_addname("\015ipv6-localnet\0")) goto DIE;
+      response_rfinish(RESPONSE_ANSWER);
+    }
+    cleanup(z);
+    return 1;
+  }
+
+  if (dns_domain_equal(d,"\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\001f\001f\003ip6\003int\0")) {
+    if (z->level) goto LOWERLEVEL;
+    if (!rqa(z)) goto DIE;
+    if (typematch(DNS_T_PTR,dtype)) {
+      if (!response_rstart(d,DNS_T_PTR,655360)) goto DIE;
+      if (!response_addname("\020ipv6-mcastprefix\0")) goto DIE;
+      response_rfinish(RESPONSE_ANSWER);
+    }
+    cleanup(z);
+    return 1;
+  }
+
+  if (dns_domain_equal(d,"\0011\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0012\0010\001f\001f\003ip6\003int\0")) {
+    if (z->level) goto LOWERLEVEL;
+    if (!rqa(z)) goto DIE;
+    if (typematch(DNS_T_PTR,dtype)) {
+      if (!response_rstart(d,DNS_T_PTR,655360)) goto DIE;
+      if (!response_addname("\015ipv6-allnodes\0")) goto DIE;
+      response_rfinish(RESPONSE_ANSWER);
+    }
+    cleanup(z);
+    return 1;
+  }
+
+  if (dns_domain_equal(d,"\0012\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0012\0010\001f\001f\003ip6\003int\0")) {
+    if (z->level) goto LOWERLEVEL;
+    if (!rqa(z)) goto DIE;
+    if (typematch(DNS_T_PTR,dtype)) {
+      if (!response_rstart(d,DNS_T_PTR,655360)) goto DIE;
+      if (!response_addname("\017ipv6-allrouters\0")) goto DIE;
+      response_rfinish(RESPONSE_ANSWER);
+    }
+    cleanup(z);
+    return 1;
+  }
+
+  if (dns_domain_equal(d,"\0011\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0010\0012\0010\001f\001f\003ip6\003int\0")) {
+    if (z->level) goto LOWERLEVEL;
+    if (!rqa(z)) goto DIE;
+    if (typematch(DNS_T_PTR,dtype)) {
+      if (!response_rstart(d,DNS_T_PTR,655360)) goto DIE;
+      if (!response_addname("\015ipv6-allhosts\0")) goto DIE;
+      response_rfinish(RESPONSE_ANSWER);
+    }
+    cleanup(z);
+    return 1;
+  }
+
+  if (dns_domain_equal(d,"\016ipv6-localhost\0") ||
+      dns_domain_equal(d,"\015ipv6-loopback\0"))
+    {
+      if (z->level) goto LOWERLEVEL;
+      if (!rqa(z)) goto DIE;
+      if (typematch(DNS_T_AAAA,dtype)) {
+	if (!response_rstart(d,DNS_T_AAAA,655360)) goto DIE;
+	if (!response_addbytes("\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001",16)) goto DIE;
+	response_rfinish(RESPONSE_ANSWER);
+      }
+      cleanup(z);
+      return 1;
+    }
+
+  if (dns_domain_equal(d,"\015ipv6-localnet\0"))
+    {
+      if (z->level) goto LOWERLEVEL;
+      if (!rqa(z)) goto DIE;
+      if (typematch(DNS_T_AAAA,dtype)) {
+	if (!response_rstart(d,DNS_T_AAAA,655360)) goto DIE;
+	if (!response_addbytes("\376\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000",16)) goto DIE;
+	response_rfinish(RESPONSE_ANSWER);
+      }
+      cleanup(z);
+      return 1;
+    }
+
+  if (dns_domain_equal(d,"\020ipv6-mcastprefix\0"))
+    {
+      if (z->level) goto LOWERLEVEL;
+      if (!rqa(z)) goto DIE;
+      if (typematch(DNS_T_AAAA,dtype)) {
+	if (!response_rstart(d,DNS_T_AAAA,655360)) goto DIE;
+	if (!response_addbytes("\377\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000",16)) goto DIE;
+	response_rfinish(RESPONSE_ANSWER);
+      }
+      cleanup(z);
+      return 1;
+    }
+
+  if (dns_domain_equal(d,"\15ipv6-allnodes\0"))
+    {
+      if (z->level) goto LOWERLEVEL;
+      if (!rqa(z)) goto DIE;
+      if (typematch(DNS_T_AAAA,dtype)) {
+	if (!response_rstart(d,DNS_T_AAAA,655360)) goto DIE;
+	if (!response_addbytes("\377\002\000\000\000\000\000\000\000\000\000\000\000\000\000\001",16)) goto DIE;
+	response_rfinish(RESPONSE_ANSWER);
+      }
+      cleanup(z);
+      return 1;
+    }
+
+  if (dns_domain_equal(d,"\17ipv6-allrouters\0"))
+    {
+      if (z->level) goto LOWERLEVEL;
+      if (!rqa(z)) goto DIE;
+      if (typematch(DNS_T_AAAA,dtype)) {
+	if (!response_rstart(d,DNS_T_AAAA,655360)) goto DIE;
+	if (!response_addbytes("\377\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002",16)) goto DIE;
+	response_rfinish(RESPONSE_ANSWER);
+      }
+      cleanup(z);
+      return 1;
+    }
+
+  if (dns_domain_equal(d,"\15ipv6-allhosts\0"))
+    {
+      if (z->level) goto LOWERLEVEL;
+      if (!rqa(z)) goto DIE;
+      if (typematch(DNS_T_AAAA,dtype)) {
+	if (!response_rstart(d,DNS_T_AAAA,655360)) goto DIE;
+	if (!response_addbytes("\377\002\000\000\000\000\000\000\000\000\000\000\000\000\000\003",16)) goto DIE;
+	response_rfinish(RESPONSE_ANSWER);
+      }
+      cleanup(z);
+      return 1;
+    }
+
   if (dns_domain_equal(d,"\0011\0010\0010\003127\7in-addr\4arpa\0")) {
     if (z->level) goto LOWERLEVEL;
     if (!rqa(z)) goto DIE;
@@ -326,9 +481,10 @@
 	if (z->level) {
 	  log_cachedanswer(d,DNS_T_A);
 	  while (cachedlen >= 4) {
-	    for (k = 0;k < 64;k += 4)
-	      if (byte_equal(z->servers[z->level - 1] + k,4,"\0\0\0\0")) {
-		byte_copy(z->servers[z->level - 1] + k,4,cached);
+	    for (k = 0;k < 256;k += 16)
+	      if (byte_equal(z->servers[z->level - 1] + k,16,V6any)) {
+		byte_copy(z->servers[z->level - 1] + k,12,V4mappedprefix);
+		byte_copy(z->servers[z->level - 1] + k + 12,4,cached);
 		break;
 	      }
 	    cached += 4;
@@ -351,7 +507,39 @@
       }
     }
 
-    if (!typematch(DNS_T_ANY,dtype) && !typematch(DNS_T_AXFR,dtype) && !typematch(DNS_T_CNAME,dtype) && !typematch(DNS_T_NS,dtype) && !typematch(DNS_T_PTR,dtype) && !typematch(DNS_T_A,dtype) && !typematch(DNS_T_MX,dtype)) {
+    if (typematch(DNS_T_AAAA,dtype)) {
+      byte_copy(key,2,DNS_T_AAAA);
+      cached = cache_get(key,dlen + 2,&cachedlen,&ttl);
+      if (cached && (cachedlen || byte_diff(dtype,2,DNS_T_ANY))) {
+	if (z->level) {
+	  log_cachedanswer(d,DNS_T_AAAA);
+	  while (cachedlen >= 16) {
+	    for (k = 0;k < 256;k += 16)
+	      if (byte_equal(z->servers[z->level - 1] + k,16,V6any)) {
+		byte_copy(z->servers[z->level - 1] + k,16,cached);
+		break;
+	      }
+	    cached += 16;
+	    cachedlen -= 16;
+	  }
+	  goto LOWERLEVEL;
+	}
+
+	log_cachedanswer(d,DNS_T_AAAA);
+	if (!rqa(z)) goto DIE;
+	while (cachedlen >= 16) {
+	  if (!response_rstart(d,DNS_T_AAAA,ttl)) goto DIE;
+	  if (!response_addbytes(cached,16)) goto DIE;
+	  response_rfinish(RESPONSE_ANSWER);
+	  cached += 16;
+	  cachedlen -= 16;
+	}
+	cleanup(z);
+	return 1;
+      }
+    }
+
+    if (!typematch(DNS_T_ANY,dtype) && !typematch(DNS_T_AXFR,dtype) && !typematch(DNS_T_CNAME,dtype) && !typematch(DNS_T_NS,dtype) && !typematch(DNS_T_PTR,dtype) && !typematch(DNS_T_A,dtype) && !typematch(DNS_T_MX,dtype) && !typematch(DNS_T_AAAA,dtype)) {
       byte_copy(key,2,dtype);
       cached = cache_get(key,dlen + 2,&cachedlen,&ttl);
       if (cached && (cachedlen || byte_diff(dtype,2,DNS_T_ANY))) {
@@ -375,14 +563,15 @@
   }
 
   for (;;) {
-    if (roots(z->servers[z->level],d)) {
+    if (sc=roots(z->servers[z->level],d)) {
       for (j = 0;j < QUERY_MAXNS;++j)
         dns_domain_free(&z->ns[z->level][j]);
       z->control[z->level] = d;
+      z->controltype[z->level] = sc;
       break;
     }
 
-    if (!flagforwardonly && (z->level < 2))
+    if (!isForwardOnly(z) && (z->level < 2))
       if (dlen < 255) {
         byte_copy(key,2,DNS_T_NS);
         byte_copy(key + 2,dlen,d);
@@ -390,7 +579,7 @@
         cached = cache_get(key,dlen + 2,&cachedlen,&ttl);
         if (cached && cachedlen) {
 	  z->control[z->level] = d;
-          byte_zero(z->servers[z->level],64);
+          byte_zero(z->servers[z->level],256);
           for (j = 0;j < QUERY_MAXNS;++j)
             dns_domain_free(&z->ns[z->level][j]);
           pos = 0;
@@ -423,19 +612,23 @@
       dns_domain_free(&z->ns[z->level][j]);
     }
 
-  for (j = 0;j < 64;j += 4)
-    if (byte_diff(z->servers[z->level] + j,4,"\0\0\0\0"))
+  for (j = 0;j < 256;j += 16)
+    if (byte_diff(z->servers[z->level] + j,16,V6any))
       break;
-  if (j == 64) goto SERVFAIL;
+  if (j == 256) goto SERVFAIL;
 
-  dns_sortip(z->servers[z->level],64);
+  dns_sortip6(z->servers[z->level],256);
   if (z->level) {
     log_tx(z->name[z->level],DNS_T_A,z->control[z->level],z->servers[z->level],z->level);
-    if (dns_transmit_start(&z->dt,z->servers[z->level],flagforwardonly,z->name[z->level],DNS_T_A,z->localip) == -1) goto DIE;
+/*    I hope this works, ipv6 shouldn't be an issue ... (prox@prolixium.com) */
+/*    if (dns_transmit_start(&z->dt,z->servers[z->level],flagforwardonly,z->name[z->level],DNS_T_A,z->localip) == -1) goto DIE; */
+    if (dns_transmit_start(&z->dt,z->servers[z->level],isForwardOnly(z),z->name[z->level],DNS_T_A,z->localip) == -1) goto DIE;
   }
   else {
     log_tx(z->name[0],z->type,z->control[0],z->servers[0],0);
-    if (dns_transmit_start(&z->dt,z->servers[0],flagforwardonly,z->name[0],z->type,z->localip) == -1) goto DIE;
+  /* Same with this ... (prox@prolixium.com) */
+/*    if (dns_transmit_start(&z->dt,z->servers[0],flagforwardonly,z->name[0],z->type,z->localip) == -1) goto DIE; */
+    if (dns_transmit_start(&z->dt,z->servers[0],isForwardOnly(z),z->name[0],z->type,z->localip) == -1) goto DIE;
   }
   return 0;
 
@@ -453,7 +646,7 @@
   buf = z->dt.packet;
   len = z->dt.packetlen;
 
-  whichserver = z->dt.servers + 4 * z->dt.curserver;
+  whichserver = z->dt.servers + 16 * z->dt.curserver;
   control = z->control[z->level];
   d = z->name[z->level];
   dtype = z->level ? DNS_T_A : z->type;
@@ -519,7 +712,7 @@
   if (!flagcname && !rcode && !flagout && flagreferral && !flagsoa)
     if (dns_domain_equal(referral,control) || !dns_domain_suffix(referral,control)) {
       log_lame(whichserver,control,referral);
-      byte_zero(whichserver,4);
+      byte_zero(whichserver,16);
       goto HAVENS;
     }
 
@@ -643,6 +836,8 @@
         pos = dns_packet_copy(buf,len,pos,header,10); if (!pos) goto DIE;
         if (byte_equal(header + 8,2,"\0\4")) {
           pos = dns_packet_copy(buf,len,pos,header,4); if (!pos) goto DIE;
+	  /* VeriSign Patch */
+	  if (*ignoreip) if(byte_equal(header,4,ignoreip)) goto NXDOMAIN;
           save_data(header,4);
           log_rr(whichserver,t1,DNS_T_A,header,4,ttl);
         }
@@ -650,6 +845,20 @@
       }
       save_finish(DNS_T_A,t1,ttl);
     }
+    else if (byte_equal(type,2,DNS_T_AAAA)) {
+      save_start();
+      while (i < j) {
+        pos = dns_packet_skipname(buf,len,records[i]); if (!pos) goto DIE;
+        pos = dns_packet_copy(buf,len,pos,header,10); if (!pos) goto DIE;
+        if (byte_equal(header + 8,2,"\0\20")) {
+          pos = dns_packet_copy(buf,len,pos,header,16); if (!pos) goto DIE;
+          save_data(header,16);
+          log_rr(whichserver,t1,DNS_T_AAAA,header,16,ttl);
+        }
+        ++i;
+      }
+      save_finish(DNS_T_AAAA,t1,ttl);
+    }
     else {
       save_start();
       while (i < j) {
@@ -723,9 +932,10 @@
           if (typematch(header,DNS_T_A))
             if (byte_equal(header + 2,2,DNS_C_IN)) /* should always be true */
               if (datalen == 4)
-                for (k = 0;k < 64;k += 4)
-                  if (byte_equal(z->servers[z->level - 1] + k,4,"\0\0\0\0")) {
-                    if (!dns_packet_copy(buf,len,pos,z->servers[z->level - 1] + k,4)) goto DIE;
+                for (k = 0;k < 256;k += 16)
+                  if (byte_equal(z->servers[z->level - 1] + k,16,V6any)) {
+		    byte_copy(z->servers[z->level - 1] + k,12,V4mappedprefix);
+                    if (!dns_packet_copy(buf,len,pos,z->servers[z->level - 1] + k + 12,4)) goto DIE;
                     break;
                   }
         pos += datalen;
@@ -818,7 +1028,7 @@
   return -1;
 }
 
-int query_start(struct query *z,char *dn,char type[2],char class[2],char localip[4])
+int query_start(struct query *z,char *dn,char type[2],char class[2],char localip[16],unsigned int scope_id)
 {
   if (byte_equal(type,2,DNS_T_AXFR)) { errno = error_perm; return -1; }
 
@@ -829,7 +1039,8 @@
   if (!dns_domain_copy(&z->name[0],dn)) return -1;
   byte_copy(z->type,2,type);
   byte_copy(z->class,2,class);
-  byte_copy(z->localip,4,localip);
+  byte_copy(z->localip,16,localip);
+  z->scope_id=scope_id;
 
   return doit(z,0);
 }
diff -uNr djbdns-1.05/query.h djbdns-1.05-new/query.h
--- djbdns-1.05/query.h	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/query.h	2003-09-16 10:09:36.000000000 -0400
@@ -13,20 +13,20 @@
   unsigned int level;
   char *name[QUERY_MAXLEVEL];
   char *control[QUERY_MAXLEVEL]; /* pointing inside name */
+  int controltype[QUERY_MAXLEVEL]; /* servers or caches */
   char *ns[QUERY_MAXLEVEL][QUERY_MAXNS];
-  char servers[QUERY_MAXLEVEL][64];
+  char servers[QUERY_MAXLEVEL][256];
   char *alias[QUERY_MAXALIAS];
   uint32 aliasttl[QUERY_MAXALIAS];
-  char localip[4];
+  char localip[16];
+  uint32 scope_id;
   char type[2];
   char class[2];
   struct dns_transmit dt;
 } ;
 
-extern int query_start(struct query *,char *,char *,char *,char *);
+extern int query_start(struct query *,char *,char *,char *,char *,unsigned int);
 extern void query_io(struct query *,iopause_fd *,struct taia *);
 extern int query_get(struct query *,iopause_fd *,struct taia *);
 
-extern void query_forwardonly(void);
-
 #endif
diff -uNr djbdns-1.05/roots.c djbdns-1.05-new/roots.c
--- djbdns-1.05/roots.c	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/roots.c	2003-09-16 10:09:36.000000000 -0400
@@ -6,23 +6,34 @@
 #include "error.h"
 #include "direntry.h"
 #include "ip4.h"
+#include "ip6.h"
 #include "dns.h"
 #include "openreadclose.h"
 #include "roots.h"
 
+static int flagforwardonly = 0;
+
+void roots_forwardonly(void)
+{
+  flagforwardonly = 1;
+}
+
 static stralloc data;
 
-static int roots_find(char *q)
+static int roots_find(char *q, int *psc)
 {
   int i;
   int j;
 
   i = 0;
   while (i < data.len) {
-    j = dns_domain_length(data.s + i);
-    if (dns_domain_equal(data.s + i,q)) return i + j;
-    i += j;
-    i += 64;
+    j = dns_domain_length(data.s + i + 1);
+    if (dns_domain_equal(data.s + i + 1,q)) {
+      *psc = (int) data.s[i];
+      return i + 1 + j;
+    }
+    i += j + 1;
+    i += 256;
   }
   return -1;
 }
@@ -30,9 +41,10 @@
 static int roots_search(char *q)
 {
   int r;
+  int sc;
 
   for (;;) {
-    r = roots_find(q);
+    r = roots_find(q, &sc);
     if (r >= 0) return r;
     if (!*q) return -1; /* user misconfiguration */
     q += *q;
@@ -40,13 +52,14 @@
   }
 }
 
-int roots(char servers[64],char *q)
+int roots(char servers[256],char *q)
 {
   int r;
-  r = roots_find(q);
+  int sc;
+  r = roots_find(q, &sc);
   if (r == -1) return 0;
-  byte_copy(servers,64,data.s + r);
-  return 1;
+  byte_copy(servers,256,data.s + r);
+  return sc;
 }
 
 int roots_same(char *q,char *q2)
@@ -54,13 +67,13 @@
   return roots_search(q) == roots_search(q2);
 }
 
-static int init2(DIR *dir)
+static int init2(DIR *dir, char flag)
 {
   direntry *d;
   const char *fqdn;
   static char *q;
   static stralloc text;
-  char servers[64];
+  char servers[256];
   int serverslen;
   int i;
   int j;
@@ -86,27 +99,28 @@
       for (i = 0;i < text.len;++i)
 	if (text.s[i] == '\n') {
 	  if (serverslen <= 60)
-	    if (ip4_scan(text.s + j,servers + serverslen))
-	      serverslen += 4;
+	    if (ip6_scan(text.s + j,servers + serverslen))
+	      serverslen += 16;
 	  j = i + 1;
 	}
-      byte_zero(servers + serverslen,64 - serverslen);
+      byte_zero(servers + serverslen,256 - serverslen);
 
+      if (!stralloc_catb(&data,&flag,1)) return 0;
       if (!stralloc_catb(&data,q,dns_domain_length(q))) return 0;
-      if (!stralloc_catb(&data,servers,64)) return 0;
+      if (!stralloc_catb(&data,servers,256)) return 0;
     }
   }
 }
 
-static int init1(void)
+static int init1(const char* subdir, char flag)
 {
   DIR *dir;
   int r;
 
-  if (chdir("servers") == -1) return 0;
+  if (chdir(subdir) == -1) return 0;
   dir = opendir(".");
   if (!dir) return 0;
-  r = init2(dir);
+  r = init2(dir, flag);
   closedir(dir);
   return r;
 }
@@ -120,7 +134,9 @@
 
   fddir = open_read(".");
   if (fddir == -1) return 0;
-  r = init1();
+  r = init1("servers", flagforwardonly ? DNSCACHES : DNSSERVERS);
+  if (fchdir(fddir) == -1) r = 0;
+  if (!init1("caches", DNSCACHES)) r = 0;
   if (fchdir(fddir) == -1) r = 0;
   close(fddir);
   return r;
diff -uNr djbdns-1.05/roots.h djbdns-1.05-new/roots.h
--- djbdns-1.05/roots.h	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/roots.h	2003-09-16 10:09:36.000000000 -0400
@@ -1,8 +1,13 @@
 #ifndef ROOTS_H
 #define ROOTS_H
 
+#define DNSSERVERS 1
+#define DNSCACHES  2
+
 extern int roots(char *,char *);
 extern int roots_same(char *,char *);
 extern int roots_init(void);
 
+extern void roots_forwardonly(void);
+
 #endif
diff -uNr djbdns-1.05/scan_xlong.c djbdns-1.05-new/scan_xlong.c
--- djbdns-1.05/scan_xlong.c	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/scan_xlong.c	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1,23 @@
+#include "scan.h"
+
+static inline int fromhex(unsigned char c) {
+  if (c>='0' && c<='9')
+    return c-'0';
+  else if (c>='A' && c<='F')
+    return c-'A'+10;
+  else if (c>='a' && c<='f')
+    return c-'a'+10;
+  return -1;
+}
+
+unsigned int scan_xlong(const char *src,unsigned long *dest) {
+  register const char *tmp=src;
+  register int l=0;
+  register unsigned char c;
+  while ((c=fromhex(*tmp))<16) {
+    l=(l<<4)+c;
+    ++tmp;
+  }
+  *dest=l;
+  return tmp-src;
+}
diff -uNr djbdns-1.05/server.c djbdns-1.05-new/server.c
--- djbdns-1.05/server.c	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/server.c	2003-09-16 10:09:36.000000000 -0400
@@ -4,6 +4,7 @@
 #include "buffer.h"
 #include "strerr.h"
 #include "ip4.h"
+#include "ip6.h"
 #include "uint16.h"
 #include "ndelay.h"
 #include "socket.h"
@@ -11,13 +12,16 @@
 #include "qlog.h"
 #include "response.h"
 #include "dns.h"
+#include "alloc.h"
+#include "iopause.h"
+#include "str.h"
 
 extern char *fatal;
 extern char *starting;
 extern int respond(char *,char *,char *);
 extern void initialize(void);
 
-static char ip[4];
+static char ip[16];
 static uint16 port;
 
 static char buf[513];
@@ -25,6 +29,11 @@
 
 static char *q;
 
+void nomem()
+{
+  strerr_die2x(111,fatal,"out of memory");
+}
+
 static int doit(void)
 {
   unsigned int pos;
@@ -82,35 +91,86 @@
 int main()
 {
   char *x;
-  int udp53;
+  int *udp53;
+  unsigned int off;
+  unsigned int cnt;
+  iopause_fd *iop;
 
   x = env_get("IP");
   if (!x)
     strerr_die2x(111,fatal,"$IP not set");
-  if (!ip4_scan(x,ip))
-    strerr_die3x(111,fatal,"unable to parse IP address ",x);
-
-  udp53 = socket_udp();
-  if (udp53 == -1)
-    strerr_die2sys(111,fatal,"unable to create UDP socket: ");
-  if (socket_bind4_reuse(udp53,ip,53) == -1)
-    strerr_die2sys(111,fatal,"unable to bind UDP socket: ");
-
+  off=cnt=0;
+  while (x[off]) {
+    unsigned int l;
+    char dummy[16];
+    l=ip6_scan(x+off,dummy);
+    if (!l)
+      strerr_die3x(111,fatal,"unable to parse IP address ",x+off);
+    cnt++;
+    if (!x[off+l]) break;
+    if (x[off+l]=='%')
+      while (x[off+l] && x[off+l]!=',') ++l;
+    if (x[off+l]!=',')
+      strerr_die3x(111,fatal,"unable to parse IP address ",x+off);
+    off+=l+1;
+  }
+  udp53=(int *) alloc(sizeof(int) *cnt);
+  if (!udp53) nomem();
+  iop=(iopause_fd *) alloc(sizeof(*iop) * cnt);
+  if (!iop) nomem();
+
+  off=cnt=0;
+  while (x[off]) {
+    unsigned int l;
+    uint32 ifid=0;
+    l=ip6_scan(x+off,ip);
+    udp53[cnt] = socket_udp6();
+    if (udp53[cnt] == -1)
+      strerr_die2sys(111,fatal,"unable to create UDP socket: ");
+    if (x[off+l]=='%') {
+      char* interface=x+off+l+1;
+      int Len=str_chr(interface,',');
+      if (interface[Len]) {
+	interface[Len]=0;
+	ifid=socket_getifidx(interface);
+	interface[Len]=',';
+      } else
+	ifid=socket_getifidx(interface);
+      l+=Len;
+    }
+    if (socket_bind6_reuse(udp53[cnt],ip,53,ifid) == -1)
+      strerr_die2sys(111,fatal,"unable to bind UDP socket: ");
+    ndelay_off(udp53[cnt]);
+    socket_tryreservein(udp53[cnt],65536);
+    iop[cnt].fd=udp53[cnt];
+    iop[cnt].events=IOPAUSE_READ;
+    cnt++;
+    if (!x[off+l]) break;
+    off+=l+1;
+  }
   droproot(fatal);
 
   initialize();
-  
-  ndelay_off(udp53);
-  socket_tryreservein(udp53,65536);
 
   buffer_putsflush(buffer_2,starting);
 
   for (;;) {
-    len = socket_recv4(udp53,buf,sizeof buf,ip,&port);
-    if (len < 0) continue;
-    if (!doit()) continue;
-    if (response_len > 512) response_tc();
-    socket_send4(udp53,response,response_len,ip,port);
-    /* may block for buffer space; if it fails, too bad */
+    struct taia stamp;
+    struct taia deadline;
+    unsigned int i;
+    uint32 ifid;
+    taia_now(&stamp);
+    taia_uint(&deadline,300);
+    taia_add(&deadline,&deadline,&stamp);
+    iopause(iop,cnt,&deadline,&stamp);
+    for (i=0;i<cnt;i++)
+      if (iop[i].revents) {
+	len = socket_recv6(udp53[i],buf,sizeof buf,ip,&port,&ifid);
+	if (len < 0) continue;
+	if (!doit()) continue;
+	if (response_len > 512) response_tc();
+	socket_send6(udp53[i],response,response_len,ip,port,ifid);
+	/* may block for buffer space; if it fails, too bad */
+      }
   }
 }
diff -uNr djbdns-1.05/sockaddr_in6.h1 djbdns-1.05-new/sockaddr_in6.h1
--- djbdns-1.05/sockaddr_in6.h1	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/sockaddr_in6.h1	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1,21 @@
+#include "haveip6.h"
+#ifdef LIBC_HAS_IP6
+#include <sys/types.h>
+#include <sys/socket.h>
+#define sockaddr_in6 blub
+#include <netinet/in.h>
+#undef sockaddr_in6
+
+struct sockaddr_in6 {
+  sa_family_t     sin6_family;    /* AF_INET6 */
+  unsigned short  sin6_port;      /* transport layer port # */
+  uint32_t        sin6_flowinfo;  /* IPv6 traffic class & flow info */
+  struct in6_addr sin6_addr;      /* IPv6 address */
+  uint32_t        sin6_scope_id;  /* set of interfaces for a scope */
+};
+
+#else
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+#endif
diff -uNr djbdns-1.05/sockaddr_in6.h2 djbdns-1.05-new/sockaddr_in6.h2
--- djbdns-1.05/sockaddr_in6.h2	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/sockaddr_in6.h2	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1,4 @@
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+
diff -uNr djbdns-1.05/socket.h djbdns-1.05-new/socket.h
--- djbdns-1.05/socket.h	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/socket.h	2003-09-16 10:09:36.000000000 -0400
@@ -2,21 +2,37 @@
 #define SOCKET_H
 
 #include "uint16.h"
+#include "uint32.h"
 
 extern int socket_tcp(void);
 extern int socket_udp(void);
+extern int socket_tcp6(void);
+extern int socket_udp6(void);
 
 extern int socket_connect4(int,const char *,uint16);
+extern int socket_connect6(int s,const char ip[16],uint16 port,uint32 scope_id);
 extern int socket_connected(int);
-extern int socket_bind4(int,char *,uint16);
+extern int socket_bind4(int,const char *,uint16);
 extern int socket_bind4_reuse(int,char *,uint16);
+extern int socket_bind6(int s,const char *ip,uint16 port,uint32 scope_id);
+extern int socket_bind6_reuse(int s,const char *ip,uint16 port,uint32 scope_id);
 extern int socket_listen(int,int);
 extern int socket_accept4(int,char *,uint16 *);
+extern int socket_accept6(int s,char *ip,uint16 *port,uint32 *scope_id);
 extern int socket_recv4(int,char *,int,char *,uint16 *);
 extern int socket_send4(int,const char *,int,const char *,uint16);
+extern int socket_recv6(int s,char *buf,unsigned int len,char *ip,uint16 *port,uint32 *scope_id);
+extern int socket_send6(int s,const char *buf,unsigned int len,const char *ip,uint16 port,uint32 scope_id);
 extern int socket_local4(int,char *,uint16 *);
 extern int socket_remote4(int,char *,uint16 *);
+extern int socket_local6(int s,char *ip,uint16 *port,uint32 *scope_id);
+extern int socket_remote6(int s,char *ip,uint16 *port,uint32 *scope_id);
 
 extern void socket_tryreservein(int,int);
 
+extern const char* socket_getifname(uint32 interface);
+extern uint32 socket_getifidx(const char *ifname);
+
+extern int noipv6;
+
 #endif
diff -uNr djbdns-1.05/socket_accept6.c djbdns-1.05-new/socket_accept6.c
--- djbdns-1.05/socket_accept6.c	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/socket_accept6.c	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1,43 @@
+#include <sys/param.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include "byte.h"
+#include "socket.h"
+#include "ip6.h"
+#include "haveip6.h"
+#include "error.h"
+
+int socket_accept6(int s,char ip[16],uint16 *port,uint32 *scope_id)
+{
+#ifdef LIBC_HAS_IP6
+  struct sockaddr_in6 sa;
+#else
+  struct sockaddr_in sa;
+#endif
+  unsigned int dummy = sizeof sa;
+  int fd;
+
+  fd = accept(s,(struct sockaddr *) &sa,&dummy);
+  if (fd == -1) return -1;
+
+#ifdef LIBC_HAS_IP6
+  if (sa.sin6_family==AF_INET) {
+    struct sockaddr_in *sa4=(struct sockaddr_in*)&sa;
+    byte_copy(ip,12,V4mappedprefix);
+    byte_copy(ip+12,4,(char *) &sa4->sin_addr);
+    uint16_unpack_big((char *) &sa4->sin_port,port);
+    return fd;
+  }
+  byte_copy(ip,16,(char *) &sa.sin6_addr);
+  uint16_unpack_big((char *) &sa.sin6_port,port);
+  if (scope_id) *scope_id=sa.sin6_scope_id;
+
+  return fd;
+#else
+  byte_copy(ip,12,V4mappedprefix);
+  byte_copy(ip+12,4,(char *) &sa.sin_addr);
+  uint16_unpack_big((char *) &sa.sin_port,port);
+  if (scope_id) *scope_id=0;
+  return fd;
+#endif
+}
diff -uNr djbdns-1.05/socket_bind.c djbdns-1.05-new/socket_bind.c
--- djbdns-1.05/socket_bind.c	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/socket_bind.c	2003-09-16 10:09:36.000000000 -0400
@@ -5,7 +5,7 @@
 #include "byte.h"
 #include "socket.h"
 
-int socket_bind4(int s,char ip[4],uint16 port)
+int socket_bind4(int s,const char ip[4],uint16 port)
 {
   struct sockaddr_in sa;
 
diff -uNr djbdns-1.05/socket_bind6.c djbdns-1.05-new/socket_bind6.c
--- djbdns-1.05/socket_bind6.c	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/socket_bind6.c	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1,43 @@
+#include <sys/param.h>
+#include "sockaddr_in6.h"
+#include "byte.h"
+#include "socket.h"
+#include "ip6.h"
+#include "haveip6.h"
+#include "error.h"
+
+int socket_bind6(int s,const char ip[16],uint16 port,uint32 scope_id)
+{
+#ifdef LIBC_HAS_IP6
+  struct sockaddr_in6 sa;
+
+  if (noipv6) {
+#endif
+    int i;
+    for (i=0; i<16; i++)
+      if (ip[i]!=0) break;
+    if (i==16 || ip6_isv4mapped(ip))
+      return socket_bind4(s,ip+12,port);
+#ifdef LIBC_HAS_IP6
+  }
+  byte_zero(&sa,sizeof sa);
+  sa.sin6_family = AF_INET6;
+  uint16_pack_big((char *) &sa.sin6_port,port);
+/*  implicit: sa.sin6_flowinfo = 0; */
+  byte_copy((char *) &sa.sin6_addr,16,ip);
+  sa.sin6_scope_id=scope_id;
+
+  return bind(s,(struct sockaddr *) &sa,sizeof sa);
+#else
+  errno=error_proto;
+  return -1;
+#endif
+}
+
+int socket_bind6_reuse(int s,const char ip[16],uint16 port,uint32 scope_id)
+{
+  int opt = 1;
+  setsockopt(s,SOL_SOCKET,SO_REUSEADDR,&opt,sizeof opt);
+  return socket_bind6(s,ip,port,scope_id);
+}
+
diff -uNr djbdns-1.05/socket_connect6.c djbdns-1.05-new/socket_connect6.c
--- djbdns-1.05/socket_connect6.c	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/socket_connect6.c	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1,39 @@
+#include <sys/param.h>
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <errno.h>
+#include "byte.h"
+#include "socket.h"
+#include "ip6.h"
+#include "haveip6.h"
+#include "error.h"
+#include "uint32.h"
+#include "ip4.h"
+
+int socket_connect6(int s,const char ip[16],uint16 port,uint32 scope_id)
+{
+#ifdef LIBC_HAS_IP6
+  struct sockaddr_in6 sa;
+
+  if (noipv6) {
+#endif
+    if (ip6_isv4mapped(ip))
+      return socket_connect4(s,ip+12,port);
+    if (byte_equal(ip,16,V6loopback))
+      return socket_connect4(s,ip4loopback,port);
+#ifdef LIBC_HAS_IP6
+  }
+  byte_zero(&sa,sizeof sa);
+  sa.sin6_family = PF_INET6;
+  uint16_pack_big((char *) &sa.sin6_port,port);
+  sa.sin6_flowinfo = 0;
+  sa.sin6_scope_id = scope_id;
+  byte_copy((char *) &sa.sin6_addr,16,ip);
+
+  return connect(s,(struct sockaddr *) &sa,sizeof sa);
+#else
+  errno=EPROTO;
+  return -1;
+#endif
+}
diff -uNr djbdns-1.05/socket_getifidx.c djbdns-1.05-new/socket_getifidx.c
--- djbdns-1.05/socket_getifidx.c	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/socket_getifidx.c	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1,13 @@
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <net/if.h>
+#include "socket.h"
+#include "haven2i.h"
+
+uint32 socket_getifidx(const char* ifname) {
+#ifdef HAVE_N2I
+  return if_nametoindex(ifname);
+#else
+  return 0;
+#endif
+}
diff -uNr djbdns-1.05/socket_noipv6.c djbdns-1.05-new/socket_noipv6.c
--- djbdns-1.05/socket_noipv6.c	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/socket_noipv6.c	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1,7 @@
+#include "haveip6.h"
+
+#ifdef LIBC_HAS_IP6
+int noipv6=0;
+#else
+int noipv6=1;
+#endif
